.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::combobox 0.2" "" "2020\-01\-04" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::combobox\f[R] \- snit widget derived from a ttk::combobox with
added dropdown list and filtering
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgw::combobox
namespace import ::dgw::combobox
combobox pathName options
pathName configure \-values list
pathName configure \-hidenohits boolean
pathName configure \-textvariable varname
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]dgw::combobox\f[R] \- is a snit widget derived from a
ttok::combobox but with the added possibility to display the list of
values available in the combobox as dropdown list.
This dropdown list can further be filtered using the given options.
If the user supplies the option \-hidenohits false.
He just gets the standard ttk::combobox
.SS COMMAND
.PP
\f[B]dgw::combobox\f[R] \f[I]pathName ?options?\f[R]
.RS
.PP
Creates and configures the \f[B]dgw::combobox\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
As the \f[B]dgw::combobox\f[R] widget is derived from the standard
ttk::combobox it interhits all options and methods from ttk::combobox.
\f[B]\-hidenohits\f[R] \f[I]boolean\f[R]
.RS
.PP
If \f[I]hidenohits\f[R] is set to true, non\-matching list entries are
not displayed in the dropdown listbox.
Defaults to true.
.RE
.SS WIDGET COMMANDS
.PP
As the dgw::combobox widget is dertived from the ttk::combobox, it has
all methods available as a ttk::combobox, see the ttk::combobox manual
from the description of the widget commands.
.SS EXAMPLE
.IP
.nf
\f[C]
   wm title . \[dq]DGApp\[dq]
   pack [label .l0 \-text \[dq]standard combobox\[dq]]
   ttk::combobox .c0 \-values [list  done1 done2 dtwo dthree four five six seven]
   pack .c0 \-side top
   pack [label .l1 \-text \[dq]combobox with filtering\[dq]]
   dgw::combobox .c1 \-values [list done1 done2 dtwo dthree four five six seven] \[rs]
        \-hidenohits true
   pack .c1 \-side top     
   pack [label .l2 \-text \[dq]combobox without filtering\[dq]]
   dgw::combobox .c2 \-values [list done1 done2 dtwo dthree four five six seven] \[rs]
        \-hidenohits false
   pack .c2 \-side top 
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the \f[B]dgw::combbox\f[R]
package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation of dgw::combobox just put the folder \f[I]dgw\f[R] in a
folder belonging to your Tcl\-library path or put combobox.tcl as
combobox\-0.2.tm to a folder dgw which belongs to your Tcl\-Module path.
The latter can be as well achieved using the \f[I]\-install\f[R] option
such as \f[C]tclsh combobox.tcl \-\-install\f[R] which will try to
install dgw::combobox into your Tcl\-module path.
## DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish combobox.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish combobox.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh combobox.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh combobox.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]combobox.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh combobox.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, a html or a pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh combobox.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > combobox.n
# html page
tclsh ../combobox.tcl \-\-man > combobox.md
pandoc \-i combobox.md \-s \-o combobox.html
# pdf
pandoc \-i combobox.md \-s \-o combobox.tex
pdflatex combobox.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage:
http://chiselapp.com/user/dgroth/repository/tclcode/index (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.SS TODO
.IP \[bu] 2
probably as usually more documentation
.IP \[bu] 2
more, real, tests
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The \f[B]combobox\f[R] widget was written by Detlef Groth, Schwielowsee,
Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2019 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.SS LICENSE
.PP
Text search dialog widget dgw::combobox, version 0.2.
.PP
Copyright (c) 2019 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
