.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::drawcanvas 0.1" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::drawcanvas\f[R] \- simple drawing tool to sketch some text,
lines, rectangles ovals on the fly.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
KEY BINDINGS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
CHANGES
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHORS
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require Tk
package require snit
package require dgw::drawcanvas
\f[R]
.fi
.SS DESCRIPTION
.PP
The widget \f[B]dgw::drawcanvas\f[R] provides a simple drawing surface
to place, lines, rextangles, ovales and text in different in a fast
manner on a canvas.
It is based on code in the Tclers Wiki:
.SS COMMAND
.PP
\f[B]dgw::drawcanvas\f[R] \f[I]pathName ?\-option value \&...?\f[R]
.RS
.PP
Creates and configures the \f[B]dgw::drawcanvas\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
As the \f[B]dgw::drawcanvas\f[R] is an extension of the standard Tk
canvas widget it supports all method and options of this widget.
The following option(s) are added by the \f[I]dgw::drawcanvas\f[R]
widget:
.PP
\f[B]\-colors\f[R] \f[I]colorList\f[R]
.RS
.PP
List of colors which can be used to fill ovals and rectangles.
Those colors are a set of pastel like colors.
.RE
.SS WIDGET COMMANDS
.PP
Each \f[B]dgw::drawcanvas\f[R] widget supports all usual methods of the
Tk canvas widget and it adds the follwing method(s):
.PP
\f[I]pathName\f[R] \f[B]eraseAll\f[R] \f[I]?ask?\f[R]
.RS
.PP
Deletes all items in the widget, if ask is true (default), then the user
will get a message box to agree on deleting all items.
.RE
.PP
\f[I]pathName\f[R] \f[B]saveCanvas\f[R] \f[I]?fileName?\f[R]
.RS
.PP
Saves the content of the canvas either as ps or if the ghostscript
interpreter is available as well as pdf file using the given filename.
If the filename is not given the user will be asked for one.
.RE
.SS EXAMPLE
.PP
In the example below we create a Markdown markup aware text editor.
.IP
.nf
\f[C]
package require dgw::drawcanvas
dgw::drawcanvas .dc
pack .dc \-side top \-fill both \-expand true
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the
\f[B]dgw::drawcanvas\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgw/drawcanvas\-0.1.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of drawcanvas.tcl.
Try \[lq]tclsh drawcanvas.tcl \[en]install\[rq] for this purpose.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish drawcanvas.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ tclsh drawcanvas.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh drawcanvas.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh drawcanvas.tcl \-\-html
\f[R]
.fi
.PP
If the tcllib Markdown package is installed, this will directly create a
HTML page \f[C]drawcanvas.html\f[R] which contains the formatted
documentation.
.PP
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh drawcanvas.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a Markdown processor for
conversion into a html, docx or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
tclsh ../drawcanvas.tcl \-\-man > drawcanvas.md
pandoc \-i drawcanvas.md \-s \-o drawcanvas.html
pandoc \-i drawcanvas.md \-s \-o drawcanvas.tex
pdflatex drawcanvas.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw package
homepage (https://chiselapp.com/user/dgroth/repository/tclcode/index) \-
various useful widgets
.SS CHANGES
.IP \[bu] 2
2020\-03\-27 \- version 0.1 started
.SS TODO
.IP \[bu] 2
github url
.SS AUTHORS
.PP
The dgw::\f[B]dgw::drawcanvas\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS Copyright
.PP
Copyright (c) 2020 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgw::drawcanvas package, version 0.1.
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
