.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::hyperhelp 0.8.2" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::hyperhelp\f[R] help system with hypertext facilitites and
table of contents outline
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
METHODS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
MARKUP LANGUAGE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
CHANGES
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
LICENSE AND COPYRIGHT
.SS SYNOPSIS
.PP
Usage as package:
.IP
.nf
\f[C]
package require dgw::hyperhelp
dgw::hyperhelp pathName \-helpfile filename ?\-option value ...?
pathName help topic
\f[R]
.fi
.PP
Usage as command line application:
.IP
.nf
\f[C]
tclsh hyperhelp.tcl filename ?\-\-commandsubst true?
\f[R]
.fi
.SS DESCRIPTION
.PP
The \f[B]dgw::hyperhelp\f[R] package is hypertext help system which can
be easily embedded into Tk applications.
It is based on code of the Tclers Wiki mainly be Keith Vetter see the
Tclers\-Wiki (https://wiki.tcl-lang.org/page/A+Hypertext+Help+System)
The difference of this package to the wiki code is, that it works on
external files, provides some \f[C]subst\f[R] support for variables and
commands as well as a browser like toolbar.
It can be as well used as standalone applications for browsing the help
files.
Markup syntax was modified towards Markdown to simplify writing help
pages as this is a common documentation language.
In practice you can create a document which is a valid Markdown document
and at the same time an usable help file.
The file <hyperhelp-markdown-sample.md> gives an example for such a
file.
.SS COMMAND
.PP
\f[B]dgw::hyperhelp\f[R] \f[I]pathName \-helpfile fileName ?\-option
value \&...?\f[R]
.RS
.PP
creates a new \f[I]hyperhelp\f[R] widget using the given widget
\f[I]pathName\f[R] and with the given \f[I]fileName\f[R].
.RE
.SS OPTIONS
.PP
The \f[B]dgw::hyperhelp\f[R] snit widget supports the following options
which should be set only at widget creation:
.PP
\f[B]\-bottomnavigation\f[R] \f[I]boolean\f[R]
.RS
.PP
Configures the hyperhelp widget if at the bottom of each help page a
textual navigation line should be displayed.
Default \f[I]false\f[R].
.RE
.PP
\f[B]\-commandsubst\f[R] \f[I]boolean\f[R]
.RS
.PP
Configures the hyperhelp widget to do substitutions using Tcl commands
within the text.
This might give some security issues if you load help files from dubious
sources, although for this most critical commands like file, exec and
socket are disaable even if this option is set to true.
Default: false
.RE
.PP
\f[B]\-dismissbutton\f[R] \f[I]boolean\f[R]
.RS
.PP
Configures the hyperhelp widget to display at the button a
\[lq]Dismiss\[rq] button.
Useful if the help page is direct parent in a toplevel to destroy this
toplevel.
Default: \f[I]false\f[R].
.RE
.PP
\f[B]\-font\f[R] \f[I]fontname\f[R]
.RS
.PP
Configures the hyperhelp widget to use the given font.
Fontnames should be given as \f[C][list fontname size]\f[R] such as for
example \f[C]\[rs][list {Linux Libertine} 12\[rs]]\f[R].
If no fontname is given the hyperhelp widget tries out a few standard
font names on Linux and Windows System.
If none of those fonts is found, it falls back to \[lq]Times New
Roman\[rq] which should be available on all platforms.
.RE
.PP
\f[B]\-helpfile\f[R] \f[I]fileName\f[R]
.RS
.PP
Configures the hyperhelp widget with the given helpfile option to be
displayed within the widget.
.RE
.PP
\f[B]\-toctree\f[R] \f[I]boolean\f[R]
.RS
.PP
Should the toc tree widget on the left be displayed.
For simple help pages, consisting only of one, two, three pages the
treeview widget might be overkill.
Please note, that this widget is also not shown if there is no table of
contents page, regardless of the \f[I]\-toctree\f[R] option.
Must be set at creation time currently.
Default: \f[I]true\f[R]
.RE
.PP
\f[B]\-toolbar\f[R] \f[I]boolean\f[R]
.RS
.PP
Should the toolbar on top be displayed.
For simple help pages, consisting only of one, two pages the toolbar
might be overkill.
Must be set at creation time currently.
Default: \f[I]true\f[R]
.RE
.SS METHODS
.PP
The \f[I]hyperhelp\f[R] widget provides the following methods:
.PP
\f[I]pathName\f[R] \f[B]getPages\f[R]
.RS
.PP
Returns the page names for the current help file.
.RE
.PP
\f[I]pathName\f[R] \f[B]getTitle\f[R]
.RS
.PP
Returns the current topic shown in the hyperhelp browser.
.RE
.PP
\f[I]pathName\f[R] \f[B]help\f[R] \f[I]topic\f[R]
.RS
.PP
Displays the given topic within widget.
If the page does not exists an error page is shown.
.RE
.SS EXAMPLE
.IP
.nf
\f[C]
package require dgw::hyperhelp
set helpfile [file join [file dirname [info script]] hyperhelp\-docu.txt]
set hhelp [dgw::hyperhelp .help \-helpfile $helpfile]
pack $hhelp \-side top \-fill both \-expand true
$hhelp help overview
\f[R]
.fi
.SS MARKUP LANGUAGE
.PP
The Markup language of the hyperhelp widget is similar to Tclers Wiki
and Markdown markup.
Here are the most important markup commands.
For a detailed description have a look at the file
\f[C]hyperhelp\-docu.txt\f[R] which contains the hyperhelp documentation
with detailed markup rules.
.PP
\f[I]Page structure:\f[R]
.PP
A help page in the help file is basically started with the title tag at
the beginning of a line and adds with 6 dashes.
See here an example for three help pages.
To shorten links in the document later as well an \f[C]alias\f[R] can be
given afterwards.
There is also support for Markdown headers as the last page shows.
.IP
.nf
\f[C]
title: Hyperhelp Title Page
alias: main

Free text can be written here with standard *Markdown* 
or \[aq]\[aq]Wiki\[aq]\[aq] syntax markup.

\-\-\-\-\-\-
title: Other Page title
alias: other
icon: acthelp16

Follows more text for the second help page. You can link
to the [main] page here also.
\-\-\-\-\-\-

## <a name=\[dq]aliasname\[dq]>Page title</a>

Text for the next page after this Markdown like header, the anchor is now an alis 
which can be used for links like here [aliasname], the link [Page title] points to the same page.
\f[R]
.fi
.PP
For the second page an other icon than the standard file icon was given
for the help page.
This icon is used for the treeview widget on the left displayed left of
the page title.
The following icons are currently available: acthelp16, bookmark, idea,
navhome16, help, sheet, folder, textfile.
.PP
\f[I]\[lq]Table of Contents\[rq] page:\f[R]
.PP
There is a special page called \[lq]Table of Contents\[rq].
The unnumbered list, probably nested, of this page will be used for the
navigation outline tree on the left.
Below is the example for the contents page which comes with the
hyperhelp help file \[lq]hyperhelp\-docu.txt\[rq].
The \[lq]Table of Contents\[rq] page should be the first page in your
documentation.
Please indent only with standard Markdown syntax compatible, so two
spaces for first level and four spaces for second level.
.IP
.nf
\f[C]
title: Table of Contents 
alias: TOC
  \- [Welcome to the Help System]
  \- [What\[aq]s New]
  \- Formatting
    \- [Basic Formatting]
    \- [Aliases]
    \- [Lists]
    \- [Substitutions]
    \- [Images]
    \- [Code Blocks]
    \- [Indentation]
  \- [Creating the TOC]
  \- [Key Bindings]
  \- [To Do]

\-\-\-\-\-\-\-
\f[R]
.fi
.PP
\f[I]Font styles:\f[R]
.RS
.IP \[bu] 2
\[cq]`\[cq]bold'\[cq]\[cq] \- \f[B]bold\f[R] (Wiki syntax), **bold** \-
\f[B]bold\f[R] (Markdown syntax)
.IP \[bu] 2
`\[cq]italic'\[cq] \- \f[I]italic\f[R] (Wiki syntax), *italic* \-
\f[I]italic\f[R] (Markdown syntax)
.IP \[bu] 2
\[ga]code\[ga] \- \f[C]code\f[R]
.RE
.PP
\f[I]Links:\f[R]
.RS
.IP \[bu] 2
hyperlinks to other help pages within the same document are created
using brackets: \f[C][overview]\f[R] \-> overview
.IP \[bu] 2
image links, where images will be embedded and shown
\f[C][image.png]\f[R]
.IP \[bu] 2
also image display and hyperlinks in Markdown format are supported.
Therefore \f[C]![](image.png)\f[R] displays an image and
\f[C][Page title](#alias)\f[R] creates a link to the page \[lq]Page
title\[rq]
.RE
.PP
\f[I]Code blocks:\f[R]
.RS
.IP \[bu] 2
code blocks are started by indenting a line with three spaces
.IP \[bu] 2
the block continues until less than three leading whitespace character
are found on the text
.RE
.PP
\f[I]Indentation:\f[R]
.RS
.IP \[bu] 2
indented blocks are done by using the pipe symbol \f[C]|\f[R] or the
greater symbol as in Markdown syntax
.IP \[bu] 2
indenting ends on lines without whitespaces as can be seen the following
example
.RE
.IP
.nf
\f[C]
 > * indented one with \[ga]code text\[ga]
   * indented two with **bold text**
   * indented three with *italic text*

 this text is again unindented
\f[R]
.fi
.PP
\f[I]Substitutions:\f[R]
.RS
.IP \[bu] 2
you can substitute variables and commands within the help page
.IP \[bu] 2
command substition is done using double brackets like in
\f[C][[package require dgw::hyperhelp]]\f[R] would embed the package
version of the hyperhelp package
.IP \[bu] 2
variable substitution is done using the Dollar variable prefix, for
instance \f[C]$::tcl_patchLevel\f[R] would embed the actual Tcl version
.IP \[bu] 2
caution: be sure to not load files from unknown sources, command
substitution should not work with commands like \f[C]file\f[R],
\f[C]exec\f[R] or \f[C]socket\f[R].
But anyway only use your own help files
.RE
.PP
\f[I]Lists:\f[R]
.RS
.IP \[bu] 2
support for list and nested lists using the standard \f[C]* item\f[R]
and \[ga]** subitem\[ga]\[ga] syntax
.IP \[bu] 2
numbered lists can be done with starting a line with \f[C]1.\f[R]
followed by a white space such as in \f[C]1. item\f[R] and
\f[C]11. subitem\f[R]
.IP \[bu] 2
dashed lists can be done with single and double dashes
.RE
.PP
\f[I]Key bindings:\f[R]
.RS
.PP
The hyperhelp window provides some standard key bindings to navigate the
content:
.RE
.RS
.IP \[bu] 2
space, next: scroll down
.IP \[bu] 2
backspace, prior: scroll up
.IP \[bu] 2
Ctrl\-k, Ctrl\-j: scroll in half page steps up and down
.IP \[bu] 2
Ctrl\-space, Ctrl\-b: scroll down or up
.IP \[bu] 2
Ctrl\-h, Alt\-Left, b: browse back history if possible
.IP \[bu] 2
Ctrl\-l, Alt\-Right: browse forward in history if possible
.IP \[bu] 2
n, p: browse forward or backward in page order
.IP \[bu] 2
Control\-Plus, Control\-Minus changes in font\-size
.IP \[bu] 2
Up, Down, Left, Right etc are used for navigation in the treeview widget
.RE
.SS INSTALLATION
.PP
Installation is easy you can install and use the
\f[B]dgw::hyperhelp\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.IP \[bu] 2
the dgtools::shistory package which can be found at the same side as the
dgw::hyperhelp package
.PP
For installation you copy the complete \f[I]dgw\f[R] and the
\f[I]dgtools\f[R] folder into a path of your \f[I]auto_path\f[R] list of
Tcl or you append the \f[I]auto_path\f[R] list with the parent dir of
the \f[I]dgw\f[R] directory.
Alternatively you can install the package as a Tcl module by creating a
file dgw/hyperhelp\-0.8.2.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of hyperhelp.tcl.
Try \[lq]tclsh hyperhelp.tcl \[en]install\[rq] for this purpose.
Please note, that in the latter case you must redo this for the
\f[C]dgtools::shistory\f[R] package.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish hyperhelp.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish hyperhelp.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you need that the dgwutils.tcl file is in
the same directory with the file \f[C]hyperhelp.tcl\f[R].
Then you can use the following command lines:
.IP
.nf
\f[C]
$ tclsh hyperhelp.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh hyperhelp.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]hyperhelp.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh hyperhelp.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a html or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
tclsh ../hyperhelp.tcl \-\-man > hyperhelp.md
pandoc \-i hyperhelp.md \-s \-o hyperhelp.html
pandoc \-i hyperhelp.md \-s \-o hyperhelp.tex
pdflatex hyperhelp.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \-
package (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.IP \[bu] 2
shtmlview \-
package (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.SS TODO
.IP \[bu] 2
some more template files (done)
.IP \[bu] 2
tests (done, could be more)
.IP \[bu] 2
github url
.IP \[bu] 2
fix for broken TOC with four indents needed (done (?))
.SS CHANGES
.IP \[bu] 2
2020\-02\-01 Release 0.5 \- first published version
.IP \[bu] 2
2020\-02\-05 Release 0.6 \- catching errors for missing images and wrong
Tcl code inside substitutions
.IP \[bu] 2
2020\-02\-07 Release 0.7
.RS 2
.IP \[bu] 2
options \f[I]\-toolbar\f[R], \f[I]\-toctree\f[R] for switchable display
.IP \[bu] 2
single page, automatic hiding of toctree and toolbar
.IP \[bu] 2
outline widget only shown if TOC exists
.IP \[bu] 2
adding Control\-Plus, Control\-Minus for font changes
.IP \[bu] 2
fix indentation and italic within indentation is now possible
.IP \[bu] 2
basic Markdown support
.RE
.IP \[bu] 2
2020\-02\-16 Release 0.8.0
.RS 2
.IP \[bu] 2
fix for Ctrl.j, Ctrk\-k keys
.IP \[bu] 2
disabled default command substitutions
.RE
.IP \[bu] 2
2020\-02\-19 Release 0.8.1
.RS 2
.IP \[bu] 2
removed bug in the within page search
.IP \[bu] 2
insertion cursors for search remains in the widget
.IP \[bu] 2
fixed bug in help page
.RE
.IP \[bu] 2
2020\-03\-02
.RS 2
.IP \[bu] 2
adding hyperhelp\-minimal example to the code
.IP \[bu] 2
adding \[en]sample option to print this to the terminal
.RE
.SS AUTHOR(s)
.PP
The \f[I]dgw::hyperhelp\f[R] package was written by Dr.\ Detlef Groth,
Schwielowsee, Germany using Keith Vetters code from the Tclers Wiki as
starting point.
.SS LICENSE AND COPYRIGHT
.PP
The dgw::hyperhelp package version 0.8.2
.PP
Copyright (c) 2019\-20 Dr.\ Detlef Groth, E\-mail:
<detlef(at)dgroth(dot)de> This library is free software; you can use,
modify, and redistribute it for any purpose, provided that existing
copyright notices are retained in all copies and that this notice is
included verbatim in any distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Dr.\ Detlef Groth, Schwielowsee, Germany.
