.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::sbuttonbar 0.6" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::sbuttonbar\f[R] \- snit widget for buttonbar with nice buttons
having rounded corners, based on old gbutton code from Steve Landers.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHORS
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgw::sbuttonbar
namespace import ::dgw::sbuttonbar
sbuttonbar pathName options
pathName cget option
pathName configure option value
pathName insert item options
pathName itemcget item option
pathName itemconfigure item option value 
pathName iteminvoke item 
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]dgw::sbuttonbar\f[R] \- is a snit widget derived from a Steve
Landers old gbutton code used in the old Tk Wikit application.
It displays a nice button with rounded corners, more pleasant than the
standard Tk button.
The button can be configures as usually using the \f[I]\-command\f[R] or
the \f[I]\-state\f[R] option.
The \f[I]\-text\f[R] option is however currently not available as the
text per default currently is the given text at button creation time.
.SS COMMAND
.PP
\f[B]dgw::sbuttonbar\f[R] \f[I]pathName ?options?\f[R]
.RS
.PP
Creates and configures the \f[B]dgw::sbuttonbar\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
\f[B]\-activefill\f[R] \f[I]color\f[R]
.RS
.PP
the fill color for the buttons if they are hovered
.RE
.PP
\f[B]\-bg\f[R] \f[I]color\f[R]
.RS
.PP
the color used as background color for the buttonbar
.RE
.PP
\f[B]\-disabledfill\f[R] \f[I]color\f[R]
.RS
.PP
the fill color for the buttons if they are disabled
.RE
.PP
\f[B]\-fill\f[R] \f[I]color\f[R]
.RS
.PP
the fill color for the buttons
.RE
.PP
\f[B]\-font\f[R] \f[I]fontname\f[R]
.RS
.PP
the font used for the sbuttonbar text
.RE
.PP
\f[B]\-padx\f[R] \f[I]integer\f[R]
.RS
.PP
the x\-padding between the buttons
.RE
.PP
\f[B]\-pady\f[R] \f[I]integer\f[R]
.RS
.PP
the y\-padding for all buttons in the buttonbar .
.RE
.SS WIDGET COMMANDS
.PP
Each \f[B]dgw::sbuttonbar\f[R] widget supports the following widget
commands.
.PP
\f[I]pathName\f[R] \f[B]cget\f[R] \f[I]option\f[R]
.RS
.PP
Returns the given dgw::sbuttonbar configuration value for the option.
.RE
.PP
\f[I]pathName\f[R] \f[B]configure\f[R] \f[I]option value ?option
value?\f[R]
.RS
.PP
Configures the dgw::sbuttonbar widget with the given options.
.RE
.PP
\f[I]pathName\f[R] \f[B]insert\f[R] \f[I]text\f[R] *?option value \&...?
.RS
.PP
Insert the given text as an item into the buttonbar and configures it
with the given option.
See \f[I]\-itemconfigure\f[R] for a list of available item options.
.RE
.PP
\f[I]pathName\f[R] \f[B]itemcget\f[R] \f[I]text option\f[R]
.RS
.PP
Returns the given configuration value for the item labeled with text.
See \f[I]\-itemconfigure\f[R] for a list of available item options.
.RE
.PP
\f[I]pathName\f[R] \f[B]itemconfigure\f[R] \f[I]text option value
?option value \&...?\f[R]
.RS
.PP
Returns the given configuration value for the item labeled with text.
Currently the following item options should be used:
.RE
.IP \[bu] 2
\f[I]\-state\f[R] is the button active or disabled, defaults to active
.IP \[bu] 2
\f[I]\-command\f[R] the command to be executed if the button is pressed
.PP
\f[I]pathName\f[R] \f[B]iteminvoke\f[R] \f[I]text\f[R]
.RS
.PP
Invokes the command configure with option \f[I]\-command\f[R] for the
item labeled with text.
Please note, that \f[I]iteminvoke\f[R] works all well for disabled
buttons.
.RE
.SS EXAMPLE
.IP
.nf
\f[C]
   proc Cmd {state} {
       global b0
       tk_messageBox \-type ok \-message \[dq]Cmd\[dq]
       if {$state == 0} {
           $b0 itemconfigure Forward \-state normal
           $b0 itemconfigure Back \-state disabled
       } else {
           $b0 itemconfigure Forward \-state disabled
           $b0 itemconfigure Back \-state normal
       }
   }
   pack [frame .f \-bg #fff] \-side top \-fill x \-expand no
   pack [dgw::sbuttonbar .f.t \-bg #fff] \-side top ;# \-fill x \-expand no
   set b0 .f.t
   $b0 insert Back  \-command [list Cmd 0]
   $b0 insert Forward \-command [list Cmd 1] \-state disabled
   $b0 insert Home 
   $b0 insert End \-command [list puts End]
   $b0 itemconfigure End \-state disabled
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the
\f[B]dgw::sbuttonbar\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgw/sbuttonbar\-0.6.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of sbuttonbar.tcl.
Try \[lq]tclsh sbuttonbar.tcl \[en]install\[rq] for this purpose.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish sbuttonbar.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish sbuttonbar.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh sbuttonbar.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh sbuttonbar.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]sbuttonbar.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh sbuttonbar.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, html or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh sbuttonbar.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > sbuttonbar.n
# html 
tclsh sbuttonbar.tcl \-\-man > sbuttonbar.md
pandoc \-i sbuttonbar.md \-s \-o sbuttonbar.html
# pdf
pandoc \-i sbuttonbar.md \-s \-o sbuttonbar.tex
pdflatex sbuttonbar.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage:
http://chiselapp.com/user/dgroth/repository/tclcode/index (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.SS TODO
.IP \[bu] 2
probably as usually more documentation
.IP \[bu] 2
more, real, tests
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The \f[B]sbuttonbar\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS LICENSE
.PP
dgw::sbuttonbar widget dgw::sbuttonbar, version 0.6.
.PP
Copyright (c)
.IP \[bu] 2
2001\-2002 by Steve Landers <steve (at) digital\-smarties(dot)com>
.IP \[bu] 2
2004 Uwe Koloska <uwe (at) koloro(dot)de>
.IP \[bu] 2
2004\-2019 Dr.\ Detlef Groth, <detlef (at) dgroth(dot)de>
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
