.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::sfilebrowser" "" "" "" ""
.hy
.SS NAME
.RS
.PP
\f[B]dgw::sfilebrowser\f[R] \- snit file browser widget
.RE
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
WIDGET BINDINGS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgw::sfilebrowser
namespace import ::dgw::sfilebrowser
sfilebrowser pathName options
pathName configure \-treemode true
pathName configure \-initialpath .
pathName configure \-viewcmd procName
pathName configure \-fileimage imgName
pathName browse dirName
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]sfilebrowser\f[R] \- tablelist based file browser widget to explore
the file system and to execute certain actions on the currently selected
file, such as opening it in an editor.
.SS COMMAND
.PP
\f[B]sfilebrowser\f[R] \f[I]pathName ?options?\f[R]
.RS
.PP
Creates and configures the \f[I]sfilebrowser\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
\f[B]\-fileimage\f[R] \f[I]imgName\f[R]
.RS
.PP
The image to be displayed left of filenames.
Defaults to the embedded image for files.
.RE
.PP
\f[B]\-initialpath\f[R] \f[I]dirName\f[R]
.RS
.PP
The directory from which the files and folders should be shown in the
sfilebrowser widget.
Defaults to the current working directory.
.RE
.PP
\f[B]\-treemode\f[R] \f[I]boolean\f[R]
.RS
.PP
Should the browser be opened in tree mode or in listbox mode?
Default is \f[I]true\f[R], which is tree mode.
.RE
.PP
\f[B]\-viewcmd\f[R] \f[I]procName\f[R]
.RS
.PP
The command to be executed id the user double clicks the entry.
Default to empty string, i.e.\ no action is performed.
.RE
.PP
The \f[B]sfilebrowser\f[R] widget inherits all options and methods of
its parent widget, the tablelist widget.
See the manual for tablelist for thowse options and methods.
Further it adds the following options in additional to tablelists
options:
.SS WIDGET COMMANDS
.PP
Each \f[B]sfilebrowser\f[R] widget has all the standard widget commands
ond options of a tablelist widget as well as the following commands:
.PP
\f[I]pathName\f[R] \f[B]browse\f[R] \f[I]dirname\f[R]
.RS
.PP
Opens the given directory name in the widget and displays its files and
directories.
.RE
.PP
\f[I]pathName\f[R] \f[B]getDirectory\f[R]
.RS
.PP
Returns the path for the current opened directory.
.RE
.PP
\f[I]pathName\f[R] \f[B]setDirectory\f[R] \f[I]dirname\f[R]
.RS
.PP
Opens the given directory name in the widget and displays its files and
directories.
Alias for the \f[I]browse\f[R] command.
.RE
.SS WIDGET BINDINGS
.PP
The \f[I]dgw::sfilebrowser\f[R] widget provides a few useful key
bindings to browse the current directory.
Such as Up and Down keys to walk one entry up and down, Backspace, to
switch to the parent directory, Ctrl\-Start to go the the first and
Ctrl\-End to go to the last directory entry.
Further if you type alphanumeric characters the selection moves to the
entry starting with these characters.
.SS EXAMPLE
.IP
.nf
\f[C]
   wm title . DGApp
   option add *Tablelist.stripeBackground   #c4e8ff
   option add *Tablelist.setGrid        yes
   pack [dgw::sfilebrowser .fb] \-side top \-fill both \-expand yes
   option add *Tablelist.stripeBackground   white
   option add *Tablelist.setGrid        no
   pack [text .text] \-side top \-fill both \-expand yes
   pack [dgw::sfilebrowser .fb2 \-treemode false] \-side top \-fill both \-expand yes
   proc viewCmd {filename} {
       if {[regexp {(txt|tcl|html)$} $filename]} {
           if [catch {open $filename r} infh] {
               puts stderr \[dq]Cannot open $filename: $infh\[dq]
               exit
           } else {
               .text delete 1.0 end
               while {[gets $infh line] >= 0} {
                   .text insert end \[dq]$line\[rs]n\[dq]
               }
               close $infh
           }
       }
   }
   .fb2 configure \-viewcmd viewCmd
   .fb2 browse /home/groth/workspace/detlef
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the
\f[B]dgw::sfilebrowser\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgw/sfilebrowser\-0.2.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of sfilebrowser.tcl.
Try \[lq]tclsh sfilebrowser.tcl \[en]install\[rq] for this purpose.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish sfilebrowser.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish sfilebrowser.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh sfilebrowser.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh sfilebrowser.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]sfilebrowser.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh sfilebrowser.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, html or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh sfilebrowser.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > sfilebrowser.n
# html page
tclsh ../sfilebrowser.tcl \-\-man > sfilebrowser.md
pandoc \-i sfilebrowser.md \-s \-o sfilebrowser.html
# pdf
pandoc \-i sfilebrowser.md \-s \-o sfilebrowser.tex
pdflatex sfilebrowser.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage:
http://chiselapp.com/user/dgroth/repository/tclcode/index (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.IP \[bu] 2
tablelist tutorial (https://www.nemethi.de/tablelist/tablelist.html) of
Csaba Nemethi which formed the code basis for this widget
.SS TODO
.IP \[bu] 2
sorting folders first, then filenames
.IP \[bu] 2
more, real, tests
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The \f[B]sfilebrowser\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
The code is mainly based on Csaba Nemethi\[cq]s demo code for his
tablelist widget.
.SS LICENSE
.PP
The widget dgw::sfilebrowser, version 0.2.
.PP
Copyright (c)
.IP \[bu] 2
2019 Dr.\ Detlef Groth, <detlef (at) dgroth(dot)de>
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
