.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::statusbar 0.2" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::statusbar\f[R] \- statusbar widget for Tk applications based
on a ttk::label and a ttk::progressbar widget
.SS Table of Contents
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgw::statusbar
dgw::statusbar pathName options
pathName configure \-textvariable varname
pathName configure \-variable varname
pathName clear 
pathname progress value
pathName set message ?value?
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]dgw::statusbar\f[R] \- is a composite widget consisiting of a
ttk::label and a ttk::progressbar widget.
It should be normally packaged at the bottom of an app\[:o]ication.
The text and the numerical progress value can be displayed either
directly using the widget commands or via the \f[I]\-textvariable\f[R]
and \f[I]\-variable\f[R] options which will be given at initialization
time, but these options can be also redifined at a later point.
.SS COMMAND
.PP
\f[B]dgw::statusbar\f[R] \f[I]pathName ?options?\f[R]
.RS
.PP
Creates and configures a new dgw::statusbar widget using the Tk window
id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
The \f[B]dgw::statusbar\f[R] widget is a composite widget where the
options are delegated to the original widgets.
.PP
\f[B]\-maximum\f[R] \f[I]value\f[R]
.RS
.PP
A floating point number specifying the maximum \-value.
Defaults to 100.
.RE
.PP
\f[B]\-textvariable\f[R] \f[I]varname\f[R]
.RS
.PP
Delegates the variable \f[I]varname\f[R] to the ttk::label as such.
.RE
.PP
\f[B]\-variable\f[R] \f[I]varname\f[R]
.RS
.PP
Delegates the variable \f[I]varname\f[R] to the ttk::progressbar.
Note that the maximum value is 100.
So you have to calculate the
.RE
.SS WIDGET COMMANDS
.PP
Each \f[B]dgw::combobox\f[R] widgets supports its own as well via the
\f[I]pathName label cmd\f[R] and \f[I]pathName progressbar cmd\f[R]
syntax all the commands of its component widgets.
.PP
\f[I]pathName\f[R] \f[B]clear\f[R] \f[I]message ?value?\f[R]
.RS
.PP
Removes the message from the label and sets to progressbar to zero.
.RE
.PP
\f[I]pathName\f[R] \f[B]label\f[R] \f[I]cmd ?option value \&...?\f[R]
.RS
.PP
Allows access to the commands of the embedded ttk::label widget.
Via configure and cget you can as well configure this internal widget.
For details on the available methods and options have a look at the
ttk::label manual page.
.RE
.PP
\f[I]pathName\f[R] \f[B]progress\f[R] \f[I]value\f[R]
.RS
.PP
Sets the progressbar to the given value.
.RE
.PP
\f[I]pathName\f[R] \f[B]progressbar\f[R] \f[I]cmd ?option value
\&...?\f[R]
.RS
.PP
Allows access to the commands of the embedded ttk::progessbar widget.
Via configure and cget you can as well configure this internal widget.
For details on the available methods and options have a look at the
ttk::progressbar manual page.
.RE
.PP
\f[I]pathName\f[R] \f[B]set\f[R] \f[I]message ?value?\f[R]
.RS
.PP
Displays the given message and value.
If the value is not given it is set to zero.
.RE
.SS EXAMPLE
.IP
.nf
\f[C]
package require dgw::progressbar
namespace import ::dgw::tlistbox
wm title . DGApp
pack [text .txt] \-side top \-fill both \-expand yes
set stb [dgw::statusbar .stb]
pack $stb \-side top \-expand false \-fill x
$stb progress 50
$stb set Connecting....
after 1000
$stb set \[dq]Connected, logging in...\[dq]
$stb progress 50
after 1000
$stb set \[dq]Login accepted...\[dq] 
$stb progress 75
after 1000
$stb set \[dq]Login done!\[dq] 90
after 1000
$stb set \[dq]Cleaning!\[dq] 95
after 1000
$stb set \[dq]\[dq] 100
set msg Sompleted
set val 90
$stb configure \-textvariable msg
$stb configure \-variable val
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can easily install and use this **
dgw::statusbar** package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in
tcllib (https://core.tcl-lang.org/tcllib/doc/trunk/embedded/index.md)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file \f[C]dgw/statusbar\-0.2.tm\f[R] in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of statusbar.tcl.
Try \[lq]tclsh statusbar.tcl \[en]install\[rq] for this purpose.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish statusbar.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish statusbar.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh statusbar.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh statusbar.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]statusbar.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh statusbar.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, a html or a pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh statusbar.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > statusbar.n
# html page
tclsh ../statusbar.tcl \-\-man > statusbar.md
pandoc \-i statusbar.md \-s \-o statusbar.html
# pdf
pandoc \-i statusbar.md \-s \-o statusbar.tex
pdflatex statusbar.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage:
http://chiselapp.com/user/dgroth/repository/tclcode/index (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.SS TODO
.IP \[bu] 2
probably as usually more documentation
.IP \[bu] 2
more, real, tests
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The \f[B]statusbar\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgw::statusbar package, version 0.2.
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
