.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::tlistbox 0.2" "" "2019\-10\-21" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::tlistbox\f[R] \- a tablelist based listbox with multiline text
support and a search entry.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
WIDGET OPTIONS
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgw::tlistbox
namespace import ::dgw::tlistbox
tlistbox pathName options
pathName configure \-searchentry boolean
pathName configure \-browsecmd script
pathName itemconfigure index \-option value
pathName itemcget index \-option
pathName iteminsert index string
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]tlistbox\f[R] \- a listbox widget based on the Csaba Nemethis
tablelist widget with support for multiline text which can be wrapped.
As \f[B]tlistbox\f[R] is based on the tablelist widget, it suppports the
standard options and commands of tablelist.
The \f[B]tlistbox\f[R] widget is a two column tablelist widget where the
second column is hidden to allow invisible storage of data belonging to
a \f[B]tlistbox\f[R] item or a cell in tablelist terms.
.PP
For convinience, and to make the widget more \f[B]listbox\f[R] like, a
few options and methods were added in addition to the tablelist options.
Beside of standard listbox functionality the user of this widget can
display on top of the \f[B]tlistbox\f[R] a search entry widget in order
to dynamically search the \f[B]tlistbox\f[R].
.SS COMMAND
.PP
\f[B]tlistbox\f[R] \f[I]pathName ?options?\f[R]
.RS
.PP
Creates and configures a new tlistbox widget using the Tk window id
\f[I]pathName\f[R] and the given \f[I]options\f[R].
.RE
.SS WIDGET OPTIONS
.PP
\f[B]\-browsecmd\f[R] \f[I]script\f[R]
.RS
.PP
Set a command if the user double clicks an entry in the listbox or
presses the \f[C]Return\f[R] key if the widget has the focus.
The widget path and the index of the item getting the event are appended
to the script call as function arguments.
So the implementation of the script should have two arguments in the
parameter list as shown in the following example:
.RE
.IP
.nf
\f[C]
   proc click {tbl idx} {
      puts [$tbl itemcget $idx \-text]
   }
   tlistbox .tl \-browsecmd click
\f[R]
.fi
.PP
Please note that the tablelist options \f[B]\-listvariable\f[R] should
be here a nested list, where each sublist should have at maximum only
two values, the first value will be in the first visible cell, the
second list value will be placed in the invisible cell.
The latter can be retrieved via \f[I]pathName itemconfigure index
\-data\f[R].
.PP
\f[B]\-searchentry\f[R] \f[I]boolean\f[R]
.PP
this also in agreement with the manual pages of the standard listbox
widget also an \f[B]item\f[R].
.RS
.PP
The user can enter text in the search widget for searching the
\f[B]tlistbox\f[R] widget, pressing \f[C]Return\f[R] in the
\f[I]entry\f[R] widget invokes the script supplied with the
\f[I]\-browsecmd\f[R] option.
.RE
.SS WIDGET COMMANDS
.PP
Each \f[B]tlistbox\f[R] widgets supports the tablelist widget commands.
Further two listbox like methods are implemented for convinience to
configure individual cells, in listbox terms also called
\f[B]items\f[R].
Please note, that you can also use in a similar way the
\f[I]cellconfigure\f[R] and \f[I]cellcget\f[R] functions of the
tablelist widget.
.PP
\f[I]pathName\f[R] \f[B]itemcget\f[R] \f[I]index option\f[R]
.RS
.PP
Retrieves the given option for the item (first cell of the row).
See \f[I]itemconfigure\f[R] for an explanation of the options.
.RE
.PP
\f[I]pathName\f[R] \f[B]itemconfigure\f[R] \f[I]index option value
?option value \&...?\f[R]
.RS
.PP
Configure the \f[B]item\f[R] (first cell of the row) indicated by
\f[I]index\f[R] with the given value.
All options mentioned in \f[I]cellconfigure\f[R] of the tablelist manual
can be used, such as \f[I]\-text\f[R], \f[I]\-foreground\f[R],
\f[I]\-background\f[R].
In addition to the tablelist cell options for the \f[B]tlistbox\f[R]
widget an option \f[I]\-data\f[R] is provided which allows storage of
text data in the hidden second column of the \f[I]tlistbox\f[R] widget.
Beside numerical indices as well \f[I]end\f[R] can be used as index.
.RE
.PP
\f[I]pathName\f[R] \f[B]iteminsert\f[R] \f[I]index string\f[R]
.RS
.PP
Insert the given string at position index into the \f[B]tlistbox\f[R]
value.
This is just a convinience function which does the same as
\f[I]tablelist insert index {\[lq]string\[rq]}\f[R] But here you
don\[cq]t need to add add extra braces.
Note, that you can not insert data text into the hidden column with this
method and you can only add one element per function call.
Example:
.RE
.IP
.nf
\f[C]
     tlistbox .tl
     .tl insert end {\[dq]Hello Text 1\[dq]}       ;# inserts all
     .tl insert end \[dq]Hello Text 2\[dq]         ;# only inserts Hello
     .tl iteminsert end \[dq]Hello Text 3\[dq]     ;# inserts all 
\f[R]
.fi
.SS EXAMPLE
.IP
.nf
\f[C]
 package require dgw::tlistbox
 namespace import ::dgw::tlistbox
 
 set data { {\[dq]B. Gates:\[rs]nThe Windows Operating System\[dq] \[dq]Hidden Data\[dq]} 
       {\[dq]L. Thorwalds: The Linux Operating System\[dq]} 
       {\[dq]C. Nemethi\[aq]s: Tablelist Programmers Guide\[dq]}
       {\[dq]J. Ousterhout: The Tcl/Tk Programming Language\[dq]}
 }
 proc click {tbl idx} {
     puts [$tbl itemcget $idx \-text]
 }
 tlistbox .tl \-listvariable data \-browsecmd click \-searchentry true
 lappend data {\[dq]A. Anonymous: Some thing else matters\[dq]}
 .tl insert end {\[dq]L. Wall: The Perl Programming Language\[dq] \[dq]1987\[dq]}
 pack .tl \-side top \-fill both \-expand yes
 .tl itemconfigure end \-foreground red
 .tl itemconfigure end \-data Hello
 puts \[dq]Hello? [.tl itemcget end \-data] \- yes!\[dq]
\f[R]
.fi
.PP
[IMAGE: tlistbox example (../img/tlistbox-01.png)]
.PP
[IMAGE: tlistbox search (../img/tlistbox-02.png)]
.SS INSTALLATION
.PP
Installation is easy you can easily install and use this
\f[B]tlistbox\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in
tcllib (https://core.tcl-lang.org/tcllib/doc/trunk/embedded/index.md)
.IP \[bu] 2
the tablelist package which can be found on C. Nemethi\[cq]s
webpage (http://www.nemethi.de/tablelist/)
.PP
If you have those Tcl packages installed, you can either use the
tlistbox package by sourcing it with:
\f[C]source /path/to/tlistbox.tcl\f[R], by copying the folder
\f[C]dgw\f[R] to a path belonging to your Tcl \f[C]$auto_path\f[R]
variable or by installing it as an Tcl\-module.
To do this, make a copy of \f[C]tlistbox.tcl\f[R] to a file like
\f[C]tlistbox\-0.1.tm\f[R] and put this file into a folder named
\f[C]dgw\f[R] where the parent folder belongs to your module path.
You must now adapt eventually your Tcl\-module path by using in your Tcl
code the command: \f[C]tcl::tm::path add /parent/dir/\f[R] of the
\f[C]dgw\f[R] directory.
For details of the latter consult see the manual page of
tcl::tm (https://www.tcl.tk/man/tcl/TclCmd/tm.htm).
.PP
Alternatively there is an install option you can use as well.
Try \f[C]tclsh tlistbox.tcl \-\-install\f[R] which should perform the
procedure described above automatically.
This requires eventually the setting of an environment variables like if
you have no write access to all your module paths.
For instance on my computer I have the following entry in my
\f[C].bashrc\f[R]
.IP
.nf
\f[C]
export TCL8_6_TM_PATH=/home/groth/.local/lib/tcl8.6
\f[R]
.fi
.PP
If I execute \f[C]tclsh tlistbox.tcl \-\-install\f[R] the file
\f[C]tlistbox.tcl\f[R] will be copied to
\f[C]/home/groth/.local/lib/tcl8.6/dgw/tlistbox\-0.1.tm\f[R] and is
thereafter available for a \f[C]package require dgw::tlistbox\f[R].
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish tlistbox.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ wish tlistbox.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh tlistbox.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh tlistbox.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]tlistbox.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh tlistbox.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown document for
conversion into a markdown processor for instance to convert it into a
man page a html or a pdf document you could execute the following
commands:
.IP
.nf
\f[C]
# man page
tclsh tlistbox.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > tlistbox.n
# html page
tclsh ../tlistbox.tcl \-\-man > tlistbox.md
pandoc \-i tlistbox.md \-s \-o tlistbox.html
# pdf
pandoc \-i tlistbox.md \-s \-o tlistbox.tex
pdflatex tlistbox.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
tablelist man page:
http://www.nemethi.de/tablelist/tablelistWidget.html (http://www.nemethi.de/tablelist/tablelistWidget.html)
.SS TODO
.IP \[bu] 2
probably as usually more documentation
.IP \[bu] 2
github url for putting the code
.SS AUTHORS
.PP
The \f[B]tlistbox\f[R] widget is based on Csaba Nemethi\[cq]s great
tablelist widget.
.PP
The \f[B]tlistbox\f[R] widget was written with his help by Detlef Groth,
Schwielowsee, Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2019 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.SS LICENSE
.PP
Single\-column listbox widget with multiline text and search entry,
dgw::tlistbox widget, version 0.2.
.PP
Copyright (c) 2019 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
